


#include <stdio.h>

#include "ad++.h"
#include "admacros.h"

void accumInt(void* acc, void* val) {
  *((int*) acc) += *((int*) val) ;
}

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ; {

  Procs2 p(3, 2) ;

  //Range t1(100, p.dim(0), BLK) ;
  BlockRange t1(100, p.dim(0)) ;
  //Range t2(100, p.dim(1), CYC, 20) ;
  BlockRange t2(100, CyclicRange(5, p.dim(1))) ;

  Range x = t1.subrng(20, 15, 3) ;
  Range y = t2.subrng(15, 25, 5) ;

  Array2<int> a(x, y, p) ;

  Range i(10) ;
  Range j = t2.subrng(20, 70, -2) ;

  Array2<int> b(i, j, p), u(i, j, p), v(i, j, p) ;

  ON(p) {
    Index ix(x), iy(y) ;
    WHERE(ix) {
      WHERE(iy) {
	a(ix, iy) = 1000 * ix + iy ;
      } EREWH(iy) ;
    } EREWH(ix) ;

    Index ii(i), ij(j) ;
    WHERE(ii) {
      WHERE(ij) {
        b(ii, ij) = 100 * ii + ij ;
	u(ii, ij) = (ii + ij) % 20 ;
	v(ii, ij) = (ii * ij) % 15 ;
      } EREWH(ij) ;
    } EREWH(ii) ;
  } NO(p) ;

  scatterComb(b, a, u, v, &accumInt) ;

  gprintf("b, u, v...\n") ;
  aprintf("%3R0%3R1%10d%10d%10d\n", b, u, v) ;

  gprintf("a...\n") ;
  aprintf("%3R0%3R1%10d\n", a) ;

  } AdlibFinalize() ;
}


